#include "sql.h"
#include "stdio.h"

/*----------------------------------------------------------------*/
/*								  */
/*  Example of bind by number					  */
/*								  */
/*----------------------------------------------------------------*/

	  SQLTCUR   cur = 0;		/* SQLBASE cursor number  */
	  SQLTRCD   rcd = 0;		/* SQLBASE return code	  */

	  main()
{
	  FILE*     fp; 		/* file pointer 	  */
	  SQLTDAP   cp; 		/* character pointer	  */
	  SQLTDAL   length;		/* length		  */
	  SQLTBNN   bnn;		/* bind number		  */
	  SQLTNBV   nbv;		/* # of bind variables	  */
	  char	    line[80];		/* input line		  */

static	  char	    ctbcom[] =		/* CREATE TABLE command   */
"CREATE TABLE X (A NUMBER, B DATETIME, C CHAR(30), D NUMBER)";

static	  char	    inscom[] =		/* INSERT command	  */
"INSERT INTO X(A, B, C, D) VALUES (:1, :2, :3, :4)";

  /*
    CONNECT TO THE DATABASE
  */

  if (rcd = sqlcnc(&cur, "DEMO", 0))
    failure("CONNECT");

  /*
    CREATE THE TABLE
  */

  if (sqlcex(cur, ctbcom, 0))
    failure("CREATE TABLE");

  /*
    COMPILE THE INSERT COMMAND
  */

  if (sqlcom(cur, inscom, 0))
    failure("INSERT COMPILE");

  /*
    INSERT THE DATA
  */

  if (!(fp = fopen("DATA", "r")))	/* open input file	  */
    failure("FILE OPEN");

  while (fgets(line, sizeof(line), fp)) /* read the input	  */
  {
    line[strlen(line) - 1] = 0; 	/* remove new line char   */

    sqlnbv(cur, &nbv);	/* OPTIONAL: could hard code a value of 4 */

    for (cp = line, bnn = 1;		/* scan the line	  */
	 bnn <= nbv; bnn++)
    {
      length = strscn(cp, ','); 	/* locate comma 	  */
      sqlbnn(cur, bnn, cp, length, 0, SQLPBUF);
      cp += length;			/* locate end		  */
      if (*cp == ',')			/* comma?		  */
	cp++;
    }

    if (sqlexe(cur))			/* insert row		  */
      failure("INSERT EXECUTE");
  }

  /*
    DISCONNECT FROM THE DATABASE
  */

  if (rcd = sqldis(cur))
  {
    cur = 0;
    failure("DISCONNECT");
  }
}
	  strscn(p, c)
	  char*     p;			/* -> string		  */
	  char	    c;			/* search character	  */
{
	  char*     cp; 		/* character pointer	  */
  for (cp = p; *cp && *cp != c; cp++);	/* scan string		  */
  return (int)(cp - p); 		/* return position	  */
}
	  failure(p)
	  char*     p;			/* pointer to string	  */
{
	  SQLTEPO   epo;		/* error position	  */
  if (cur)				/* cursor connected?	  */
  {
    sqlrcd(cur, &rcd);			/* get the error	  */
    sqlepo(cur, &epo);			/* get error position	  */
    sqldis(cur);
  }
  printf("Failure on %s rcd=%d, epo=%d\n",p,rcd,epo);
  exit(1);
}
